/***** Autogenerated from runtime.in *****/
/*****
 * gen_runtime.in
 * Tom Prince 2005/4/15
 *
 * Generated runtime functions.
 *
 *****/

#include "angle.h"
#include "pair.h"
#include "transform.h"
#include "path.h"
#include "pen.h"
#include "guide.h"
#include "picture.h"
#include "drawpath.h"
#include "drawfill.h"
#include "drawclipbegin.h"
#include "drawclipend.h"
#include "drawlabel.h"
#include "drawverbatim.h"
#include "drawgsave.h"
#include "drawgrestore.h"
#include "drawlayer.h"
#include "drawimage.h"
#include "drawgroup.h"
#include "fileio.h"
#include "genv.h"
#include "builtin.h"
#include "texfile.h"
#include "pipestream.h"
#include "parser.h"

using namespace vm;
using namespace camp;
using namespace settings;

namespace run {
using camp::pair;
}



namespace run {

void gen0__label(vm::stack *s)
{
  pen * p = pop<pen *>(s);
  pair a = pop<pair>(s);
  pair z = pop<pair>(s);
  double r = pop<double>(s);
  string * t = pop<string *>(s);
  picture * pic = pop<picture *>(s);

  drawLabel *d = new drawLabel(*t,r,z,a,p);
  pic->append(d);
}

void gen1_basealign(vm::stack *s)
{
  int n = pop<int>(s);

  { s->push<pen*>(new pen(n >= 0 && n < nBaseLine 
                   ? (BaseLine) n
                   : DEFBASE)); return; }
}

void gen2_draw(vm::stack *s)
{
  pen * n = pop<pen *>(s);
  path p = pop<path>(s);
  picture * pic = pop<picture *>(s);

  drawPath *d = new drawPath(p,*n);
  pic->append(d);
}

void gen3_fill(vm::stack *s)
{
  double rb = pop<double>(s);
  pair b = pop<pair>(s);
  pen * penb = pop<pen *>(s);
  double ra = pop<double>(s);
  pair a = pop<pair>(s);
  pen * pena = pop<pen *>(s);
  path p = pop<path>(s);
  picture * pic = pop<picture *>(s);

  drawFill *d = new drawFill(p,*pena,a,ra,*penb,b,rb);
  pic->append(d);
}

// Clip a picture to a path using the given fill rule.
// Subsequent additions to the picture will not be affected by the path.
void gen4_clip(vm::stack *s)
{
  pen * n = pop<pen *>(s);
  path p = pop<path>(s);
  picture * pic = pop<picture *>(s);

  pic->prepend(new drawClipBegin(p,*n));
  pic->append(new drawClipEnd());
}

void gen5_beginclip(vm::stack *s)
{
  pen * n = pop<pen *>(s);
  path p = pop<path>(s);
  picture * pic = pop<picture *>(s);

  pic->append(new drawClipBegin(p,*n,false));
}

void gen6_endclip(vm::stack *s)
{
  picture * pic = pop<picture *>(s);

  pic->append(new drawClipEnd(false));
}

void gen7_gsave(vm::stack *s)
{
  picture * pic = pop<picture *>(s);

  pic->append(new drawGsave());
}

void gen8_grestore(vm::stack *s)
{
  picture * pic = pop<picture *>(s);

  pic->append(new drawGrestore());
}

void gen9_begingroup(vm::stack *s)
{
  picture * pic = pop<picture *>(s);

  pic->append(new drawBegin());
}

void gen10_endgroup(vm::stack *s)
{
  picture * pic = pop<picture *>(s);

  pic->append(new drawEnd());
}

void gen11_add(vm::stack *s)
{
  picture * from = pop<picture *>(s);
  picture * to = pop<picture *>(s);

  to->add(*from);
}

void gen12_prepend(vm::stack *s)
{
  picture * from = pop<picture *>(s);
  picture * to = pop<picture *>(s);

  to->prepend(*from);
}

void gen13_fileprefix(vm::stack *s)
{

  { s->push<string>(outname); return; }
}

// Interactive mode
void gen14_interact(vm::stack *s)
{
  bool interaction = pop<bool>(s);

  if(interact::interactive) settings::suppressStandard=!interaction;
}

void gen15_interact(vm::stack *s)
{

  { s->push<bool>(interact::interactive && !settings::suppressStandard); return; }
}

// System commands
void gen16_system(vm::stack *s)
{
  string * str = pop<string *>(s);

  if(settings::suppressStandard) { s->push<int>(0); return; }
  
  if(safe) error("system() call disabled; override with option -unsafe");
  else { s->push<int>(System(str->c_str())); return; }
}

void gen17_abort(vm::stack *s)
{
  string * msg = pop<string *>(s);

  error(msg->c_str());
}

// Path operations
void gen18_point(vm::stack *s)
{
  int n = pop<int>(s);
  path p = pop<path>(s);

  { s->push<pair>(p.point(n)); return; }
}

void gen19_point(vm::stack *s)
{
  double t = pop<double>(s);
  path p = pop<path>(s);

  { s->push<pair>(p.point(t)); return; }
}

void gen20_precontrol(vm::stack *s)
{
  int n = pop<int>(s);
  path p = pop<path>(s);

  { s->push<pair>(p.precontrol(n)); return; }
}

void gen21_precontrol(vm::stack *s)
{
  double t = pop<double>(s);
  path p = pop<path>(s);

  { s->push<pair>(p.precontrol(t)); return; }
}

void gen22_postcontrol(vm::stack *s)
{
  int n = pop<int>(s);
  path p = pop<path>(s);

  { s->push<pair>(p.postcontrol(n)); return; }
}

void gen23_postcontrol(vm::stack *s)
{
  double t = pop<double>(s);
  path p = pop<path>(s);

  { s->push<pair>(p.postcontrol(t)); return; }
}

void gen24_dir(vm::stack *s)
{
  int n = pop<int>(s);
  path p = pop<path>(s);

  { s->push<pair>(unit(p.direction(n))); return; }
}

void gen25_dir(vm::stack *s)
{
  double t = pop<double>(s);
  path p = pop<path>(s);

  { s->push<pair>(unit(p.direction(t))); return; }
}

void gen26_reverse(vm::stack *s)
{
  path p = pop<path>(s);

  { s->push<path>(p.reverse()); return; }
}

void gen27_subpath(vm::stack *s)
{
  int e = pop<int>(s);
  int b = pop<int>(s);
  path p = pop<path>(s);

  { s->push<path>(p.subpath(b,e)); return; }
}

void gen28_subpath(vm::stack *s)
{
  double e = pop<double>(s);
  double b = pop<double>(s);
  path p = pop<path>(s);

  { s->push<path>(p.subpath(b,e)); return; }
}

void gen29_length(vm::stack *s)
{
  path p = pop<path>(s);

  { s->push<int>(p.length()); return; }
}

void gen30_cyclic(vm::stack *s)
{
  path p = pop<path>(s);

  { s->push<bool>(p.cyclic()); return; }
}

void gen31_straight(vm::stack *s)
{
  int i = pop<int>(s);
  path p = pop<path>(s);

  { s->push<bool>(p.straight(i)); return; }
}

void gen32_arclength(vm::stack *s)
{
  path p = pop<path>(s);

  { s->push<double>(p.arclength()); return; }
}

void gen33_arctime(vm::stack *s)
{
  double dval = pop<double>(s);
  path p = pop<path>(s);

  { s->push<double>(p.arctime(dval)); return; }
}

void gen34_dirtime(vm::stack *s)
{
  pair z = pop<pair>(s);
  path p = pop<path>(s);

  { s->push<double>(p.directiontime(z)); return; }
}

void gen35_intersect(vm::stack *s)
{
  path y = pop<path>(s);
  path x = pop<path>(s);

  { s->push<pair>(intersectiontime(x,y)); return; }
}

} // namespace run

namespace trans {

void gen_base_venv(venv &ve)
{
  addFunc(ve, run::gen0__label, primVoid(), "_label", primPicture(), primString(), primReal(), primPair(), primPair(), primPen());
  addFunc(ve, run::gen1_basealign, primPen(), "basealign", primInt());
  addFunc(ve, run::gen2_draw, primVoid(), "draw", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen3_fill, primVoid(), "fill", primPicture(), primPath(), primPen(), primPair(), primReal(), primPen(), primPair(), primReal());
  addFunc(ve, run::gen4_clip, primVoid(), "clip", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen5_beginclip, primVoid(), "beginclip", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen6_endclip, primVoid(), "endclip", primPicture());
  addFunc(ve, run::gen7_gsave, primVoid(), "gsave", primPicture());
  addFunc(ve, run::gen8_grestore, primVoid(), "grestore", primPicture());
  addFunc(ve, run::gen9_begingroup, primVoid(), "begingroup", primPicture());
  addFunc(ve, run::gen10_endgroup, primVoid(), "endgroup", primPicture());
  addFunc(ve, run::gen11_add, primVoid(), "add", primPicture(), primPicture());
  addFunc(ve, run::gen12_prepend, primVoid(), "prepend", primPicture(), primPicture());
  addFunc(ve, run::gen13_fileprefix, primString() , "fileprefix");
  addFunc(ve, run::gen14_interact, primVoid(), "interact", primBoolean());
  addFunc(ve, run::gen15_interact, primBoolean(), "interact");
  addFunc(ve, run::gen16_system, primInt(), "system", primString());
  addFunc(ve, run::gen17_abort, primVoid(), "abort", primString());
  addFunc(ve, run::gen18_point, primPair(), "point", primPath(), primInt());
  addFunc(ve, run::gen19_point, primPair(), "point", primPath(), primReal());
  addFunc(ve, run::gen20_precontrol, primPair(), "precontrol", primPath(), primInt());
  addFunc(ve, run::gen21_precontrol, primPair(), "precontrol", primPath(), primReal());
  addFunc(ve, run::gen22_postcontrol, primPair(), "postcontrol", primPath(), primInt());
  addFunc(ve, run::gen23_postcontrol, primPair(), "postcontrol", primPath(), primReal());
  addFunc(ve, run::gen24_dir, primPair(), "dir", primPath(), primInt());
  addFunc(ve, run::gen25_dir, primPair(), "dir", primPath(), primReal());
  addFunc(ve, run::gen26_reverse, primPath(), "reverse", primPath());
  addFunc(ve, run::gen27_subpath, primPath(), "subpath", primPath(), primInt(), primInt());
  addFunc(ve, run::gen28_subpath, primPath(), "subpath", primPath(), primReal(), primReal());
  addFunc(ve, run::gen29_length, primInt(), "length", primPath());
  addFunc(ve, run::gen30_cyclic, primBoolean(), "cyclic", primPath());
  addFunc(ve, run::gen31_straight, primBoolean(), "straight", primPath(), primInt());
  addFunc(ve, run::gen32_arclength, primReal(), "arclength", primPath());
  addFunc(ve, run::gen33_arctime, primReal(), "arctime", primPath(), primReal());
  addFunc(ve, run::gen34_dirtime, primReal(), "dirtime", primPath(), primPair());
  addFunc(ve, run::gen35_intersect, primPair(), "intersect", primPath(), primPath());
}

} // namesapce trans
